// LETTURA INGRESSI (SWITCH)
//
// Esempio di lettura di stato di alcuni ingressi
// ed in base alla loro lettura viene determinato
// lo stato delle uscite
//
// Corso AUTOMA-20 ITS 18/06/2021
//

// Definizione delle costanti
#define LED_VERDE   10
#define LED_ROSSO   13
#define LED_BLU      7

#define INT_SX		 2
#define INT_DX       3

bool Sinistro;
bool Destro;
int  LedVerde, LedRosso, LedBlu;

// ********************************************
// INIZIALIZZAZIONE DEL SISTEMA
// ********************************************
void setup()
{
  // Definizione dei pin di I/O
  pinMode(LED_VERDE, OUTPUT);
  pinMode(LED_ROSSO, OUTPUT);
  pinMode(LED_BLU, OUTPUT);
  pinMode(INT_SX, INPUT);
  pinMode(INT_DX, INPUT);
  // All'inizio tutte le uscite sono spente
  digitalWrite( LED_VERDE, LOW );
  digitalWrite( LED_ROSSO, LOW );
  digitalWrite( LED_BLU, LOW );
  // Le variabili sono tutte azzerate
  Sinistro = Destro = false;
}

// ********************************************
// CICLO RIPETITIVO DEL PROGRAMMA UTENTE
// ********************************************
void loop()
{
    // **************************************** 
  	// Lettura degli ingressi e memorizzazione 
    // **************************************** 
    Sinistro = digitalRead(INT_SX);
  	Destro = digitalRead(INT_DX);
  
    // **************************************** 
    // Elaborazione delle variabili in base
    // allo stato acquisito degli ingressi
    // **************************************** 
  	if( Sinistro ) 
      LedVerde = HIGH;
    else
      LedVerde = LOW;
  	if( Destro ) 
      LedRosso = HIGH;
    else
      LedRosso = LOW;
  
    // **************************************** 
    // Impostazione FISICA delle uscite in base
    // al valore memorizzato nelle variabili
    // **************************************** 
  	digitalWrite( LED_VERDE, LedVerde );
    digitalWrite( LED_ROSSO, LedRosso );
}

